﻿Imports Microsoft.VisualBasic
Imports Syncfusion.Schedule
Imports Syncfusion.Windows.Forms
Imports Syncfusion.Windows.Forms.Schedule
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks
Imports System.Windows.Forms

Namespace GridScheduleSample
	Partial Public Class AppointmentForm
		Inherits MetroForm

        Private schedulegrid As ScheduleControl
        Private appointEvent As ShowingAppointFormEventArgs
        Private colorOptions As List(Of String)

        Public Sub New(ByVal control As ScheduleControl, e As ShowingAppointFormEventArgs)
            InitializeComponent()
            Me.schedulegrid = control
            Me.appointEvent = e
        End Sub

        Private Sub AppointmentForm_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
            colorOptions = New List(Of String)()
            colorOptions.Add("None")
            colorOptions.Add("Important")
            colorOptions.Add("Business")
            colorOptions.Add("Personal")
            colorOptions.Add("Vacation")
            colorOptions.Add("Must Attend")
            colorOptions.Add("Travel Required")
            colorOptions.Add("Needs Preparation")
            colorOptions.Add("Birthday")
            colorOptions.Add("Anniversary")
            colorOptions.Add("Phone Call")
            Me.comboBox1.DataSource = colorOptions

            Dim apunte As Cls_AgendaApunte = CType(Me.appointEvent.Item, Cls_AgendaApunte)

            Me.comboBox1.SelectedIndex = Me.appointEvent.Item.LabelValue

            Me.StartDateDateTimePickerAdv.Value = apunte.StartTime
            Me.StartDateDateTimePickerAdv.CustomFormat = "dd/MM/yyyy"
            Me.StartTimeDateTimePickerAdv.Value = apunte.StartTime
            Me.EndDateDateTimePickerAdv.Value = apunte.EndTime
            Me.EndDateDateTimePickerAdv.CustomFormat = "dd/MM/yyyy"
            Me.EndTimeDateTimePickerAdv.Value = apunte.EndTime
            Me.SubjectTextBoxExt.Text = apunte.Subject
            Me.ContentTextBoxExt.Text = apunte.Content
            Me.AllDayCheckBoxAdv.Checked = apunte.AllDay
            Me.AsocTextBoxExt.Text = apunte.asociacion
        End Sub


        Private Sub cancel_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cancel.Click
			Me.Close()
		End Sub

        Private Sub ok_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ok.Click
            'Create a new schedule appointment
            Dim item As Cls_AgendaApunte = CType(Me.schedulegrid.DataSource.NewScheduleAppointment(), Cls_AgendaApunte)
            Dim sd As Date = Me.StartDateDateTimePickerAdv.Value
            Dim st As DateTime = Me.StartTimeDateTimePickerAdv.Value
                Dim sdt As DateTime = New DateTime(sd.Year, sd.Month, sd.Day, st.Hour, st.Minute, st.Second)

                Dim ed As Date = Me.EndDateDateTimePickerAdv.Value
                Dim et As DateTime = Me.EndTimeDateTimePickerAdv.Value
                Dim edt As DateTime = New DateTime(ed.Year, ed.Month, ed.Day, et.Hour, et.Minute, et.Second)
                If Me.AllDayCheckBoxAdv.Checked Then
                'Si es tot el dia posam hora inici - fi
                sdt = New DateTime(sd.Year, sd.Month, sd.Day, 8, 0, 0)
                edt = New DateTime(sd.Year, sd.Month, sd.Day, 19, 0, 0)
            End If
            item.UniqueID = Me.appointEvent.Item.UniqueID
            item.StartTime = sdt
            item.EndTime = edt
                item.Subject = Me.SubjectTextBoxExt.Text
                item.LabelValue = Me.comboBox1.SelectedIndex
                item.asociacion = Me.AsocTextBoxExt.Text
                item.Content = Me.ContentTextBoxExt.Text
            item.AllDay = False
            'Appointment can be added in ScheduleDataProvider
            Me.schedulegrid.DataSource.AddItem(item)
            'Me.schedulegrid.DataSource = provider
            Me.schedulegrid.GetScheduleHost().SetDataToDayPanels()
            Me.Close()
        End Sub


    End Class
End Namespace
