﻿Imports System
Imports System.Data
Imports Syncfusion.Schedule

Public Class Cls_Agenda_BD
    Inherits ScheduleDataProvider

    Public Property masterList As ScheduleAppointmentList
    Private dt As DataTable

    Public Sub New()
        MyBase.New()
        Me.dt = New DataTable()
        Dim app As New Cls_AgendaApunte
        dt.Columns.Add("AllDay", GetType(Boolean))
        dt.Columns.Add("Asociacion", GetType(String))
        dt.Columns.Add("EndTime", GetType(Date))
        dt.Columns.Add("StartTime", GetType(Date))
        dt.Columns.Add("Subject", GetType(String))
        dt.Columns.Add("UniqueID", GetType(Integer))
        dt.Columns.Add("Content", GetType(String))
    End Sub

    Public Sub createApunte(ByRef ap As Cls_AgendaApunte)
        ap.UniqueID = Me.dt.Rows.Count + 1
        Me.dt.Rows.Add({ap.AllDay, ap.asociacion, ap.EndTime, ap.StartTime, ap.Subject, ap.UniqueID, ap.Content})
        Me.dt.AcceptChanges()
    End Sub
    Public Sub updateApunte(ap As Cls_AgendaApunte)
        Dim advRow As DataRow() = dt.Select("UniqueID=" & ap.UniqueID)
        Me.dt.Rows(0)("AllDay") = ap.AllDay
        Me.dt.Rows(0)("Asociacion") = ap.asociacion
        Me.dt.Rows(0)("EndTime") = ap.EndTime
        Me.dt.Rows(0)("StartTime") = ap.StartTime
        Me.dt.Rows(0)("Subject") = ap.Subject
        Me.dt.Rows(0)("Content") = ap.Content
        Me.dt.AcceptChanges()
    End Sub
    Public Sub deleteApunte(ap As Cls_AgendaApunte)
        Dim advRow As DataRow() = dt.Select("UniqueID=" & ap.UniqueID)
        dt.Rows.Remove(advRow(0))
        Me.dt.AcceptChanges()
    End Sub

    'Public Overrides Sub CommitChanges()

    'End Sub
    'Public Overrides Function GetLabels() As ILookUpObjectList
    '    If m_labels Is Nothing Then
    '        m_labels = New LookUpObjectList(New DataView())
    '    End If
    '    Return Cls_Agenda_BD.m_labels
    'End Function
    'Public Overrides Function GetMarkers() As ILookUpObjectList
    '    If m_labels Is Nothing Then
    '        m_labels = New LookUpObjectList(New DataView())
    '    End If
    '    Return Cls_Agenda_BD.m_markers
    'End Function
    'Public Overrides Function GetOwners() As IScheduleResourceList
    '    Return MyBase.GetOwners()
    'End Function
    'Public Overrides Function GetReminders() As ILookUpObjectList
    '    If m_labels Is Nothing Then
    '        m_labels = New LookUpObjectList(New DataView())
    '    End If
    '    Return Cls_Agenda_BD.m_reminder
    'End Function

    Public Overrides Function GetSchedule(startDate As DateTime, endDate As DateTime) As IScheduleAppointmentList
        Dim list As New ScheduleAppointmentList()
        Dim start As DateTime = startDate.[Date]
        Dim [end] As DateTime = endDate.[Date]
        For Each item As ScheduleAppointment In Me.masterList
            'item.EndTime.AddMinutes(-1) is to make sure an item that ends at midnight is not shown on the next days calendar
            If (item.StartTime.[Date] >= start AndAlso item.StartTime.[Date] <= [end]) OrElse (item.EndTime.AddMinutes(-1).[Date] > start AndAlso item.EndTime.[Date] <= [end]) Then
                list.Add(item)
            End If
        Next
        list.SortStartTime()
        Return list
    End Function

    Public Overrides Function GetScheduleForDay(day As DateTime) As IScheduleAppointmentList
        Dim list As New ScheduleAppointmentList()
        day = day.[Date]
        For Each item As ScheduleAppointment In Me.masterList
            'do not want anything that ends at 12AM on the day
            If item.StartTime.[Date] = day OrElse (item.EndTime.[Date] = day AndAlso item.EndTime > day) Then
                list.Add(item)
            End If
        Next
        'DisplayList(string.Format("*************day {0}", day), list);
        Return list
    End Function

    'Public Overrides Function GetScheduleForDay(day As DateTime, owner As Integer) As IScheduleAppointmentList

    'End Function

    Public Overrides Function NewScheduleAppointment() As IScheduleAppointment
        Return New Cls_AgendaApunte()
    End Function

    Public Overrides Sub AddItem(item As IScheduleAppointment)

        If item.UniqueID = -1 Then
            createApunte(CType(item, Cls_AgendaApunte))
            Me.masterList.Add(item)
        Else
            Dim k As Integer = 0
            For Each app As IScheduleAppointment In Me.masterList
                If app.UniqueID = item.UniqueID Then
                    Exit For
                End If
                k = k + 1
            Next
            Me.masterList.Item(k) = item
            updateApunte(CType(item, Cls_AgendaApunte))
        End If
    End Sub

    Public Overrides Sub RemoveItem(item As IScheduleAppointment)
        Me.masterList.Remove(item)
        deleteApunte(CType(item, Cls_AgendaApunte))
    End Sub

    'Public Overrides Sub SaveModifiedItem(appModifiedItem As IScheduleAppointment, appOriginalItem As IScheduleAppointment)

    'End Sub





End Class
