﻿Imports System
Imports System.Data
Imports System.Drawing
Imports System.Globalization
Imports System.Windows.Forms
Imports Syncfusion.Schedule
Imports Syncfusion.Windows.Forms.Grid
Imports Syncfusion.Windows.Forms.Schedule

Public Class FrmScheduler

    Public Const darkGreen As String = "#27ae60"
    Public Const mediumGreen As String = "#2ecc71"
    Public Const lightGreen As String = "#77D69F"
    Public Const softGreen As String = "#E3FCED"



    Public Sub New()
        '
        ' Required for Windows Form Designer support
        '
        InitializeComponent()


        Me.ScheduleControl1.Culture = CultureInfo.CreateSpecificCulture("es-ES")

        ScheduleGrid.DisplayStrings(0) = "Error delimitador de cierre"
        ScheduleGrid.DisplayStrings(1) = "(ninguno)"
        ScheduleGrid.DisplayStrings(2) = "Semana del "
        ScheduleGrid.DisplayStrings(3) = "Comenzando "
        ScheduleGrid.DisplayStrings(4) = " Haga doble clic para agregar evento de todo el del día"
        ScheduleGrid.DisplayStrings(5) = "A "
        ScheduleGrid.DisplayStrings(6) = "De "
        ScheduleGrid.DisplayStrings(7) = "¿Eliminar esta cita?"
        ScheduleGrid.DisplayStrings(8) = "Eliminar cita"
        ScheduleGrid.DisplayStrings(9) = "Nueva Cita"
        ScheduleGrid.DisplayStrings(10) = "Nueva Cita (Todo el día)"
        ScheduleGrid.DisplayStrings(11) = "Editar Cita"
        ScheduleGrid.DisplayStrings(12) = "Eliminar Cita"
        ScheduleGrid.DisplayStrings(13) = "Dia"
        ScheduleGrid.DisplayStrings(14) = "Semana laboral"
        ScheduleGrid.DisplayStrings(15) = "Semana"
        ScheduleGrid.DisplayStrings(16) = "Mes"
        ScheduleGrid.DisplayStrings(17) = "Click para cambiar a vista diaria"
        ScheduleGrid.DisplayStrings(18) = "Click para más citas."



        Me.ScheduleControl1.ScheduleType = ScheduleViewType.Month
        Me.ScheduleControl1.Appearance.VisualStyle = Syncfusion.Windows.Forms.GridVisualStyles.Metro

        Me.ScheduleControl1.Appearance.MonthCalendarStartDayOfWeek = DayOfWeek.Monday
        Me.ScheduleControl1.Appearance.WeekCalendarStartDayOfWeek = DayOfWeek.Monday
        Me.ScheduleControl1.Appearance.NavigationCalendarStartDayOfWeek = DayOfWeek.Monday

        Me.ScheduleControl1.Appearance.EnableAdvancedToolTip = True

        Me.ScheduleControl1.Appearance.Hours24 = True
        Me.ScheduleControl1.Appearance.PrimeTimeStart = 8
        Me.ScheduleControl1.Appearance.PrimeTimeEnd = 19

        Dim dataProvider As New Cls_Agenda_BD()
        dataProvider.masterList = New ScheduleAppointmentList()
        Me.ScheduleControl1.DataSource = dataProvider
        Me.ScheduleControl1.DataSource.SaveOnCloseBehaviorAction = SaveOnCloseBehavior.SaveWithoutPrompt

        AddHandler Me.ScheduleControl1.ShowingAppointmentForm, AddressOf scheduleControl1_ShowingAppointmentForm
        AddHandler Me.ScheduleControl1.ItemChanging, AddressOf scheduleControl1_ItemChanging

        AddHandler ScheduleControl1.GetScheduleHost().QueryCellInfo, AddressOf cheduleControl1_QueryCellInfo



    End Sub

    Private Sub cheduleControl1_QueryCellInfo(sender As Object, e As GridQueryCellInfoEventArgs)
        If e.ColIndex = 6 Then
            'Applies back color for 6th column.
            e.Style.BackColor = Color.Pink
        End If
    End Sub

    Private Sub scheduleControl1_ShowingAppointmentForm(ByVal sender As Object, ByVal e As ShowingAppointFormEventArgs)
        'Cancel the default appointform for schedule control
        e.Cancel = True
        'Shows the Custom appointment form
        Dim form = New GridScheduleSample.AppointmentForm(Me.ScheduleControl1, e)
        form.ShowDialog()
    End Sub

    Private Sub scheduleControl1_ItemChanging(ByVal sender As Object, ByVal e As ScheduleAppointmentCancelEventArgs)

        If e.Action = ItemAction.TimeDrag AndAlso (e.CurrentItem.StartTime <> e.ProposedItem.StartTime Or e.CurrentItem.EndTime <> e.ProposedItem.EndTime) Then
            CType(Me.ScheduleControl1.DataSource, Cls_Agenda_BD).updateApunte(CType(e.ProposedItem, Cls_AgendaApunte))
        End If

    End Sub


    Private Sub FrmScheduler_Load(sender As Object, e As EventArgs) Handles Me.Load
        Me.ScheduleControl1.Appearance.AllDayBackColor = ColorTranslator.FromHtml(lightGreen)
        Me.ScheduleControl1.Appearance.WorkWeekHeaderBackColor = ColorTranslator.FromHtml(lightGreen)
        Me.ScheduleControl1.Appearance.TodayBackColor = ColorTranslator.FromHtml(darkGreen)
        Me.ScheduleControl1.Appearance.MoreItemArrowBorderColor = ColorTranslator.FromHtml(darkGreen)
        Me.ScheduleControl1.Appearance.NavigationCalendarHeaderColor = ColorTranslator.FromHtml(darkGreen)
        Me.ScheduleControl1.Appearance.NavigationCalendarTodayBackColor = ColorTranslator.FromHtml(darkGreen)
        Me.ScheduleControl1.Appearance.NavigationCalendarSelectionColor = ColorTranslator.FromHtml(softGreen)

    End Sub
End Class